#version 130

uniform mat4 u_ProjectionMatrix = mat4(1.0);
uniform mat4 u_ViewMatrix = mat4(1.0);

in vec3  a_Position;
in ivec3 a_TileOffset;

out vec4 v_Position; // in camera coordinates
flat out ivec3 v_TileOffset;

const float TILE_SIZE = 0.5;

void main()
{
    v_Position = u_ProjectionMatrix * u_ViewMatrix * vec4(a_Position + vec3(a_TileOffset), 1.0) * TILE_SIZE;
    gl_Position = v_Position;

    v_TileOffset = a_TileOffset;
}